package org.ioc.commons.flowcontrol.actioncontroller;

/**
 * The action controller is used to delegate functionallity which will be
 * carried out by an external entity.
 * 
 * The actions are invoked expecting some other entity had bound the action for
 * processing.
 * 
 * The actions are defined using the imperative tense, such as
 * 'ShowEntity','GoToMainview', etc. since its porpouse is to command an
 * external entity to execute something.
 * 
 * @author Jesús Lunar Pérez
 * 
 * @param <A>
 *            Action type
 */
public interface ActionController<A extends Enum<? extends IsExternalAction>> extends ActionControllerBinder<A>,
		ActionControllerTrigger<A> {

}
