package org.ioc.commons.flowcontrol.actioncontroller;

/**
 * Trigger for actions
 * 
 * @author Jesús Lunar Pérez
 *
 * @param <A> Action type
 */
public interface ActionControllerTrigger<A extends Enum<? extends IsExternalAction>> {
	/**
	 * Invokes an action to be processed externally.
	 * 
	 * @param action	Action which is being invoked.
	 * @param params	Parameters tha will be sent along with the action 
	 */	
	void invokeAction(A action, Object... params);
}
