package org.ioc.commons.flowcontrol.actioncontroller;

/**
 * Handler for actions
 * 
 * @author Jesús Lunar Pérez
 * 
 * @param <A>
 *            Action type
 */
public interface ActionHandler<A extends Enum<? extends IsExternalAction>> {

	/**
	 * Method which will be called when a bound action is invoked.
	 * 
	 * @param sender
	 *            Entity which invoked the action
	 * @param action
	 *            Invoked action
	 * @param params
	 *            Sent parameters along with the action
	 */
	void handleAction(Object sender, A action, Object... params);
}
