package org.ioc.commons.flowcontrol.eventbus;

/**
 * The event bus is used to communicate that something has happend.
 * 
 * The events are defined using the past tense, such as
 * 'ElementLoaded','WindowOpened', etc. since its porpouse is to indicate that
 * something happened.
 * 
 * @author Jesús Lunar Pérez
 * 
 * @param <E>	Event type
 */
public interface EventBus<E extends Enum<? extends IsEvent>> extends EventBusBinder<E>, EventBusTrigger<E>, IsEventBus {
}
