package org.ioc.commons.flowcontrol.operationmanager.impl;

import org.ioc.commons.flowcontrol.operationmanager.IsOperation;
import org.ioc.commons.flowcontrol.operationmanager.OperationHandler;
import org.ioc.commons.ui.HasLoader;

/**
 * A factory for creating operation handlers for common components.
 * 
 * @author Jesús Lunar Pérez
 * 
 */
public final class OperationHandlerFactory {
	private OperationHandlerFactory() {
		// No instanciable
	}

	public static <O extends Enum<? extends O> & IsOperation> OperationHandler<O> forLoaders(HasLoader... loaders) {
		return new HasLoaderOperationHandler<O>(loaders);
	}

}
