package org.ioc.commons.impl.gwt.client.flowcontrol;

import org.ioc.commons.flowcontrol.HasFlowControl;
import org.ioc.commons.flowcontrol.actioncontroller.ActionController;
import org.ioc.commons.flowcontrol.actioncontroller.IsExternalAction;
import org.ioc.commons.flowcontrol.eventbus.EventBus;
import org.ioc.commons.flowcontrol.eventbus.IsEvent;
import org.ioc.commons.flowcontrol.operationmanager.IsOperation;
import org.ioc.commons.flowcontrol.operationmanager.OperationManager;
import org.ioc.commons.impl.gwt.client.flowcontrol.actioncontroller.GwtActionControllerImpl;
import org.ioc.commons.impl.gwt.client.flowcontrol.eventbus.GwtEventBusImpl;
import org.ioc.commons.impl.gwt.client.flowcontrol.operationmanager.GwtOperationManagerImpl;

public class GwtFlowController<E extends Enum<? extends IsEvent>, O extends Enum<? extends IsOperation>, A extends Enum<? extends IsExternalAction>>
		implements HasFlowControl<E, O, A> {

	protected final GwtEventBusImpl<E> eventbus;
	protected final GwtOperationManagerImpl<O> operationManager;
	protected final GwtActionControllerImpl<A> actionController;

	public GwtFlowController(com.google.web.bindery.event.shared.EventBus eventBus) {
		this.eventbus = new GwtEventBusImpl<E>(eventBus);
		this.operationManager = new GwtOperationManagerImpl<O>(eventBus);
		this.actionController = new GwtActionControllerImpl<A>(eventBus);
	}

	final public EventBus<E> eventBus() {
		return this.eventbus;
	}

	final public OperationManager<O> operationManager() {
		return this.operationManager;
	}

	final public ActionController<A> actionController() {
		return this.actionController;
	}

}
