package org.ioc.commons.impl.gwt.client.ui;

import org.ioc.commons.ui.HasValue;

public class HasValueWrapper<D> implements HasValue<D>{

	private com.google.gwt.user.client.TakesValue<D> wrapped;

	private HasValueWrapper(com.google.gwt.user.client.TakesValue<D> wrapped) {
		this.wrapped = wrapped;
	}

	@Override
	public void setValue(D value) {
		this.wrapped.setValue(value);
	}

	@Override
	public D getValue() {
		return this.wrapped.getValue();
	}
	
	public static <D> HasValue<D> from(com.google.gwt.user.client.TakesValue<D> gwtHasValue) {
		return new HasValueWrapper<D>(gwtHasValue);
	}

}
