package org.ioc.commons.impl.gwt.integration.client.dataaccess.requestfactory;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import org.ioc.commons.integration.dataaccess.dao.IsDaoFactory;
import org.ioc.commons.integration.dataaccess.dao.IsEntityId;

import com.google.web.bindery.requestfactory.shared.EntityProxy;
import com.google.web.bindery.requestfactory.shared.RequestContext;

@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
public @interface RFMapping {

	@Target(ElementType.ANNOTATION_TYPE)
	@Retention(RetentionPolicy.RUNTIME)
	public @interface Dao {
		Class<? extends org.ioc.commons.integration.dataaccess.dao.Dao<? extends IsDaoFactory>> dao();

		Class<? extends RequestContext> request();
	}

	public @interface EntityDao {
		Class<? extends org.ioc.commons.integration.dataaccess.dao.EntityDao<?, ?, ? extends IsDaoFactory>> entityDao();

		Class<? extends RequestContext> request();

		Class<? extends EntityProxy> proxy();

		Class<? extends IsEntityId> id();
	}

	Dao[] plainDaos() default {};

	EntityDao[] entityDaos() default {};
}
