package org.ioc.commons.impl.gwt.integration.client.dataaccess.requestfactory.rebind.internal;

import java.util.HashMap;
import java.util.Map;

import org.ioc.commons.integration.dataaccess.dao.EntityDao;
import org.ioc.commons.integration.dataaccess.dao.IsDaoFactory;
import org.ioc.commons.integration.dataaccess.dao.SubscriptionChangesBinder;
import org.ioc.commons.integration.dataaccess.dao.Subscriptor;

import com.google.web.bindery.event.shared.EventBus;
import com.google.web.bindery.requestfactory.shared.EntityProxy;

public class RFSubscriptor<P extends EntityProxy, I, F extends IsDaoFactory> implements Subscriptor<P, I> {

	private RFSubscriptionBinder<P, I, F> subscriptionBinder;
	private Map<P, RFSubscriptionBinder<P, I, F>> subscriptionOnProxiesBinders = new HashMap<P, RFSubscriptionBinder<P, I, F>>();
	private Class<P> entityProxyClass;
	private EventBus gwtEventBus;
	private EntityDao<P, I, F> entityDao;

	public RFSubscriptor(Class<P> entityProxyClass, EventBus gwtEventBus, EntityDao<P, I, F> entityDao) {
		this.entityProxyClass = entityProxyClass;
		this.gwtEventBus = gwtEventBus;
		this.entityDao = entityDao;
	}

	@Override
	public SubscriptionChangesBinder<P, I> subscribeChanges() {
		return (this.subscriptionBinder == null) ? (this.subscriptionBinder = new RFSubscriptionBinder<P, I, F>(
				this.entityProxyClass, this.gwtEventBus, this.entityDao)) : this.subscriptionBinder;
	}

	@Override
	public SubscriptionChangesBinder<P, I> subscribeChanges(P object) {

		RFSubscriptionBinder<P, I, F> subscriptionModificationBinder = subscriptionOnProxiesBinders.get(object);

		if (subscriptionModificationBinder == null) {
			subscriptionModificationBinder = new RFSubscriptionBinder<P, I, F>(entityProxyClass, gwtEventBus,
					this.entityDao);
			subscriptionModificationBinder.setEntityProxy(object);
			subscriptionOnProxiesBinders.put(object, subscriptionModificationBinder);
		}

		return subscriptionModificationBinder;
	}

}
