package org.ioc.commons.integration.dataaccess.dao;

/**
 * 
 * @author Jesús Lunar Pérez
 * 
 * @param <T>
 *            Entity type
 * @param <I>
 *            Unique entity identifier type
 */
public interface Subscriptor<T, I> {
	/**
	 * Subscription for being notified on all changes performed on entities of
	 * type T.
	 * 
	 * @return A subscription binder for all the entities of type T
	 */
	SubscriptionChangesBinder<T, I> subscribeChanges();

	/**
	 * Subscription for being notified on all changes performed on the object.
	 * 
	 * @param object
	 *            Object for watching changes
	 * @return A subscription binder for all changes on the object.
	 */
	SubscriptionChangesBinder<T, I> subscribeChanges(T object);
}
