package org.ioc.commons.integration.service;

import org.ioc.commons.flowcontrol.common.Callback;

/**
 * Utility interface created by managing the obtained result from a server
 * request.
 * 
 * @param <S>
 *            Response from the asyncronous callback from the service.
 * @author Jesús Lunar Pérez
 */
public abstract class ServiceCallback<S> implements Callback<S, Throwable> {

	// TODO: To include exception controller
	@Override
	public abstract void onSuccess(S result);

	public void onFailure(Throwable e) {
		// Override me
	}

}
