package org.ioc.commons.ui;

import org.ioc.commons.flowcontrol.actioncontroller.ActionControllerBinder;
import org.ioc.commons.flowcontrol.actioncontroller.IsExternalAction;
import org.ioc.commons.flowcontrol.eventbus.EventBusBinder;
import org.ioc.commons.flowcontrol.eventbus.IsEvent;
import org.ioc.commons.flowcontrol.operationmanager.IsOperation;
import org.ioc.commons.flowcontrol.operationmanager.OperationManagerBinder;

/**
 * Elements which inherite from this interface define all the features from a display.
 * 
 * A display is the interface which normally presenters recive for managing and controlling.
 * 
 * @author Jesús Lunar Pérez
 * 
 */
public interface IsDisplay<E extends Enum<? extends IsEvent>, O extends Enum<? extends IsOperation>, A extends Enum<? extends IsExternalAction>> extends IsWidget {
	EventBusBinder<E> eventBus();

	OperationManagerBinder<O> operationManager();

	ActionControllerBinder<A> actionController();
}
